Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_scatterv.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_scatterv.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_scatterv.cpp	(revision 1520)
@@ -25,16 +25,16 @@
     ::MPI_Type_get_extent(to_mpi_type(sendtype), &lb, &datasize);
 
-    int ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
-    int num_ep = comm.ep_comm_ptr->size_rank_info[1].second;
+    int ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
+    int num_ep = comm->ep_comm_ptr->size_rank_info[1].second;
 
     assert(recvcount == sendcounts[ep_rank_loc]);
 
     if(ep_rank_loc == local_root)
-      comm.my_buffer->void_buffer[local_root] = const_cast<void*>(sendbuf);
+      comm->my_buffer->void_buffer[local_root] = const_cast<void*>(sendbuf);
 
     MPI_Barrier_local(comm);
 
     #pragma omp critical (_scatterv)      
-    memcpy(recvbuf, comm.my_buffer->void_buffer[local_root]+datasize*displs[ep_rank_loc], datasize * recvcount);
+    memcpy(recvbuf, comm->my_buffer->void_buffer[local_root]+datasize*displs[ep_rank_loc], datasize * recvcount);
     
 
@@ -45,20 +45,20 @@
                    MPI_Datatype recvtype, int root, MPI_Comm comm)
   {
-    if(!comm.is_ep)
+    if(!comm->is_ep)
     {
-      return ::MPI_Scatterv(sendbuf, sendcounts, displs, to_mpi_type(sendtype), recvbuf, recvcount, to_mpi_type(recvtype), root, to_mpi_comm(comm.mpi_comm));
+      return ::MPI_Scatterv(sendbuf, sendcounts, displs, to_mpi_type(sendtype), recvbuf, recvcount, to_mpi_type(recvtype), root, to_mpi_comm(comm->mpi_comm));
     }
    
     assert(sendtype == recvtype);
 
-    int ep_rank = comm.ep_comm_ptr->size_rank_info[0].first;
-    int ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
-    int mpi_rank = comm.ep_comm_ptr->size_rank_info[2].first;
-    int ep_size = comm.ep_comm_ptr->size_rank_info[0].second;
-    int num_ep = comm.ep_comm_ptr->size_rank_info[1].second;
-    int mpi_size = comm.ep_comm_ptr->size_rank_info[2].second;
+    int ep_rank = comm->ep_comm_ptr->size_rank_info[0].first;
+    int ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
+    int mpi_rank = comm->ep_comm_ptr->size_rank_info[2].first;
+    int ep_size = comm->ep_comm_ptr->size_rank_info[0].second;
+    int num_ep = comm->ep_comm_ptr->size_rank_info[1].second;
+    int mpi_size = comm->ep_comm_ptr->size_rank_info[2].second;
 
-    int root_mpi_rank = comm.rank_map->at(root).second;
-    int root_ep_loc = comm.rank_map->at(root).first;
+    int root_mpi_rank = comm->ep_rank_map->at(root).second;
+    int root_ep_loc = comm->ep_rank_map->at(root).first;
 
     bool is_master = (ep_rank_loc==0 && mpi_rank != root_mpi_rank ) || ep_rank == root;
@@ -90,5 +90,5 @@
       for(int i=0; i<ep_size; i++)
       {
-        recvcounts[comm.rank_map->at(i).second]++;
+        recvcounts[comm->ep_rank_map->at(i).second]++;
       }
 
@@ -96,5 +96,5 @@
         my_displs[i] = my_displs[i-1] + recvcounts[i-1];
 
-      ::MPI_Gatherv(local_ranks.data(), num_ep, to_mpi_type(MPI_INT), ranks.data(), recvcounts.data(), my_displs.data(), to_mpi_type(MPI_INT), root_mpi_rank, to_mpi_comm(comm.mpi_comm));
+      ::MPI_Gatherv(local_ranks.data(), num_ep, to_mpi_type(MPI_INT), ranks.data(), recvcounts.data(), my_displs.data(), to_mpi_type(MPI_INT), root_mpi_rank, to_mpi_comm(comm->mpi_comm));
     }
 
@@ -124,9 +124,9 @@
       local_sendbuf = new void*[datasize * local_sendcount];
  
-      ::MPI_Gather(&local_sendcount, 1, to_mpi_type(MPI_INT), recvcounts.data(), 1, to_mpi_type(MPI_INT), root_mpi_rank, to_mpi_comm(comm.mpi_comm));
+      ::MPI_Gather(&local_sendcount, 1, to_mpi_type(MPI_INT), recvcounts.data(), 1, to_mpi_type(MPI_INT), root_mpi_rank, to_mpi_comm(comm->mpi_comm));
 
       if(is_root) for(int i=1; i<mpi_size; i++) my_displs[i] = my_displs[i-1] + recvcounts[i-1];
 
-      ::MPI_Scatterv(tmp_sendbuf, recvcounts.data(), my_displs.data(), to_mpi_type(sendtype), local_sendbuf, num_ep*count, to_mpi_type(recvtype), root_mpi_rank, to_mpi_comm(comm.mpi_comm));
+      ::MPI_Scatterv(tmp_sendbuf, recvcounts.data(), my_displs.data(), to_mpi_type(sendtype), local_sendbuf, num_ep*count, to_mpi_type(recvtype), root_mpi_rank, to_mpi_comm(comm->mpi_comm));
 
       // printf("my_displs = %d %d %d %d\n", my_displs[0], my_displs[1], my_displs[2], my_displs[3] );
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_send.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_send.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_send.cpp	(revision 1520)
@@ -12,31 +12,24 @@
 
 
-namespace ep_lib {
-
-
+namespace ep_lib 
+{
+  
   int MPI_Send(void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm)
   {
-    if(!comm.is_ep)
-      return ::MPI_Send(buf, count, to_mpi_type(datatype), dest, tag, to_mpi_comm(comm.mpi_comm));
-    if(comm.is_intercomm)
-    {
-      MPI_Request request;
-      MPI_Status status;
-      MPI_Isend(buf, count, datatype, dest, tag, comm, &request);
-      MPI_Wait(&request, &status);
-    }
-    else
-    {
-      int ep_src_loc  = comm.ep_comm_ptr->size_rank_info[1].first;
-      int ep_dest_loc = comm.ep_comm_ptr->comm_list->rank_map->at(dest).first;
-      int mpi_tag     = tag_combine(tag, ep_src_loc, ep_dest_loc);
-      int mpi_dest    = comm.ep_comm_ptr->comm_list->rank_map->at(dest).second;
-
-      ::MPI_Send(buf, count, to_mpi_type(datatype), mpi_dest, mpi_tag, to_mpi_comm(comm.mpi_comm));
-      //printf("call mpi_send for intracomm, dest = %d, tag = %d\n", dest, tag);
-    }
-    //check_sum_send(buf, count, datatype, dest, tag, comm);
-
-    return 0;
+    if(!comm->is_ep)       return MPI_Send_mpi(buf, count, datatype, dest, tag, comm);
+    if(comm->is_intercomm) return MPI_Send_intercomm(buf, count, datatype, dest, tag, comm);
+    
+    Debug("\nMPI_Send with EP\n");
+    
+    int ep_src_loc  = comm->ep_comm_ptr->size_rank_info[1].first;
+    int ep_dest_loc = comm->ep_comm_ptr->comm_list[0]->ep_rank_map->at(dest).first;
+    int mpi_tag     = tag_combine(tag, ep_src_loc, ep_dest_loc);
+    int mpi_dest    = comm->ep_comm_ptr->comm_list[0]->ep_rank_map->at(dest).second;
+
+#ifdef _check_sum    
+    check_sum_send(buf, count, datatype, dest, tag, comm);
+#endif
+
+    return ::MPI_Send(buf, count, to_mpi_type(datatype), mpi_dest, mpi_tag, to_mpi_comm(comm->mpi_comm));
   }
 
@@ -44,269 +37,293 @@
   int MPI_Ssend(void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm)
   {
-    if(!comm.is_ep)
-    {
-      return ::MPI_Ssend(buf, count, to_mpi_type(datatype), dest, tag, to_mpi_comm(comm.mpi_comm));
-    }
-
+    if(!comm->is_ep)       return MPI_Ssend_mpi(buf, count, datatype, dest, tag, comm);
+    if(comm->is_intercomm) return MPI_Ssend_intercomm(buf, count, datatype, dest, tag, comm);
+    
+    Debug("\nMPI_Ssend with EP\n");
+
+    int ep_src_loc  = comm->ep_comm_ptr->size_rank_info[1].first;
+    int ep_dest_loc = comm->ep_comm_ptr->comm_list[0]->ep_rank_map->at(dest).first;
+    int mpi_tag     = tag_combine(tag, ep_src_loc, ep_dest_loc);
+    int mpi_dest    = comm->ep_comm_ptr->comm_list[0]->ep_rank_map->at(dest).second;
+    
+#ifdef _check_sum    
+    check_sum_send(buf, count, datatype, dest, tag, comm);
+#endif
+    
+    return ::MPI_Ssend(buf, count, to_mpi_type(datatype), mpi_dest, mpi_tag, to_mpi_comm(comm->mpi_comm));
+  }
+  
+
+
+
+
+  int MPI_Isend(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request)
+  {
+    if(!comm->is_ep)       return MPI_Isend_mpi(buf, count, datatype, dest, tag, comm, request);
+    if(comm->is_intercomm) return MPI_Isend_intercomm(buf, count, datatype, dest, tag, comm, request);
+
+    Debug("\nMPI_Isend with EP\n");
+   
+    int src_rank;
+    MPI_Comm_rank(comm, &src_rank);
+
+
+#ifdef _check_sum    
+    check_sum_send(buf, count, datatype, dest, tag, comm);
+#endif
+    
+    *request = new ep_request;
+    memcheck("new "<< *request <<" : in ep_lib::MPI_Isend, *request = new ep_request");
+
+    (*request)->mpi_request = new ::MPI_Request;
+    memcheck("new "<< (*request)->mpi_request <<" : in ep_lib::MPI_Isend, (*request)->mpi_request = new ::MPI_Request");
+    
+
+    int ep_src_loc  = comm->ep_comm_ptr->size_rank_info[1].first;
+    int ep_dest_loc = comm->ep_comm_ptr->comm_list[0]->ep_rank_map->at(dest).first;
+    int mpi_tag     = tag_combine(tag, ep_src_loc, ep_dest_loc);
+    int mpi_dest    = comm->ep_comm_ptr->comm_list[0]->ep_rank_map->at(dest).second;
+
+    (*request)->ep_src  = src_rank;
+    (*request)->ep_tag  = tag;
+    (*request)->ep_datatype = datatype;
+
+    (*request)->type = 1;    // used in wait
+    (*request)->comm = comm;
+    (*request)->buf = const_cast<void*>(buf);
+
+
+    return ::MPI_Isend(buf, count, to_mpi_type(datatype), mpi_dest, mpi_tag, to_mpi_comm(comm->mpi_comm), to_mpi_request_ptr(*request));
+  }
+
+
+
+
+  int MPI_Issend(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request)
+  {
+ 
+    if(!comm->is_ep) return MPI_Issend_mpi(buf, count, datatype, dest, tag, comm, request);
+    if(comm->is_intercomm) return MPI_Issend_intercomm(buf, count, datatype, dest, tag, comm, request);
+
+    Debug("\nMPI_Issend with EP\n");
+   
+    int src_rank;
+    MPI_Comm_rank(comm, &src_rank);
+
+
+#ifdef _check_sum    
+    check_sum_send(buf, count, datatype, dest, tag, comm);
+#endif
+    
+    *request = new ep_request;
+    memcheck("new "<< *request <<" : in ep_lib::MPI_Issend, *request = new ep_request");
+
+    (*request)->mpi_request = new ::MPI_Request;
+    memcheck("new "<< (*request)->mpi_request <<" : in ep_lib::MPI_Issend, (*request)->mpi_request = new ::MPI_Request");
+    
+
+    int ep_src_loc  = comm->ep_comm_ptr->size_rank_info[1].first;
+    int ep_dest_loc = comm->ep_comm_ptr->comm_list[0]->ep_rank_map->at(dest).first;
+    int mpi_tag     = tag_combine(tag, ep_src_loc, ep_dest_loc);
+    int mpi_dest    = comm->ep_comm_ptr->comm_list[0]->ep_rank_map->at(dest).second;
+
+    (*request)->ep_src  = src_rank;
+    (*request)->ep_tag  = tag;
+    (*request)->ep_datatype = datatype;
+
+    (*request)->type = 1;    // used in wait
+    (*request)->comm = comm;
+    (*request)->buf = const_cast<void*>(buf);
+    
+    return ::MPI_Issend(buf, count, to_mpi_type(datatype), mpi_dest, mpi_tag, to_mpi_comm(comm->mpi_comm), to_mpi_request_ptr(*request));    
+  }
+  
+  int MPI_Send_mpi(void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm)
+  {
+    Debug("\nMPI_Send with MPI\n");
+    return ::MPI_Send(buf, count, to_mpi_type(datatype), dest, tag, to_mpi_comm(comm->mpi_comm));
+  }
+  
+  int MPI_Send_intercomm(void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm)
+  {
+    Debug("\nMPI_Send_intercomm with EP\n");
+    MPI_Request request;
+    MPI_Status status;
+    MPI_Isend(buf, count, datatype, dest, tag, comm, &request);
+    MPI_Wait(&request, &status);
+    return MPI_SUCCESS;
+  }
+  
+  
+  int MPI_Ssend_mpi(void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm)
+  {
+    Debug("\nMPI_Ssend with MPI\n");
+    return ::MPI_Ssend(buf, count, to_mpi_type(datatype), dest, tag, to_mpi_comm(comm->mpi_comm));
+  }
+  
+
+  int MPI_Ssend_intercomm(void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm)
+  {
+    Debug("\nMPI_Ssend_intercomm with EP\n");
     MPI_Request request;
     MPI_Status status;
     MPI_Issend(buf, count, datatype, dest, tag, comm, &request);
     MPI_Wait(&request, &status);
-    //check_sum_send(buf, count, datatype, dest, tag, comm);
-    return 0;
-  }
-  
-
-
-
-
-  int MPI_Isend(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request)
-  {
-    Debug("\nMPI_Isend with EP\n");
-    int src_rank;
-    MPI_Comm_rank(comm, &src_rank);
-
-    
-
-    if(!comm.is_ep)
+    return MPI_SUCCESS;
+  }
+  
+  int MPI_Isend_mpi(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request)
+  {
+    Debug("\nMPI_Isend with MPI\n");
+    
+    int src_rank;
+    MPI_Comm_rank(comm, &src_rank);
+    
+    *request = new ep_request;
+    memcheck("new "<< *request <<" : in ep_lib::MPI_Isend_mpi, *request = new ep_request");
+
+    (*request)->mpi_request = new ::MPI_Request;
+    memcheck("new "<< (*request)->mpi_request <<" : in ep_lib::MPI_Isend_mpi, (*request)->mpi_request = new ::MPI_Request");
+      
+    (*request)->ep_src = src_rank;
+    (*request)->ep_tag = tag;
+    (*request)->ep_datatype = datatype;
+    (*request)->type = 1;
+    (*request)->comm = comm;
+    
+    return ::MPI_Isend(buf, count, to_mpi_type(datatype), dest, tag, to_mpi_comm(comm->mpi_comm), to_mpi_request_ptr(*request));
+  }
+  
+  int MPI_Isend_intercomm(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request)
+  {
+    Debug("\nMPI_Isend_intercomm with EP\n");
+
+#ifdef _check_sum    
+    check_sum_send(buf, count, datatype, dest, tag, comm);
+#endif
+
+    int src_comm_label  = comm->ep_comm_ptr->comm_label;
+    int dest_comm_label = comm->ep_comm_ptr->intercomm->intercomm_rank_map->at(dest).second.second;
+    
+    int src_rank;
+    MPI_Comm_rank(comm, &src_rank);
+
+    
+    *request = new ep_request;
+    memcheck("new "<< *request <<" : in ep_lib::MPI_Isend_intercomm, *request = new ep_request");
+
+    (*request)->mpi_request = new ::MPI_Request;
+    memcheck("new "<< (*request)->mpi_request <<" : in ep_lib::MPI_Isend_intercomm, (*request)->mpi_request = new ::MPI_Request");
+    
+
+    int ep_src_loc  = comm->ep_rank_map->at(src_rank).first;
+    int ep_dest_loc = comm->ep_comm_ptr->intercomm->intercomm_rank_map->at(dest).first;
+    int mpi_tag     = tag_combine(tag, ep_src_loc, ep_dest_loc);
+    int mpi_dest    = comm->ep_comm_ptr->intercomm->intercomm_rank_map->at(dest).second.first;
+
+#ifdef _showinfo
+    printf("Send : ep_src_loc = %d, ep_dest_loc = %d, mpi_src = %d, mpi_dest = %d, mpi_tag = %d\n", ep_src_loc, ep_dest_loc, comm->ep_comm_ptr->size_rank_info[2].first, mpi_dest, mpi_tag);
+#endif
+    
+
+    (*request)->ep_src  = src_rank;
+    (*request)->ep_tag  = tag;
+    (*request)->ep_datatype = datatype;
+
+    (*request)->type = 1;    // used in wait
+    (*request)->comm = comm;
+    (*request)->buf = const_cast<void*>(buf);
+
+
+    if(src_comm_label == dest_comm_label)
     {
-      ::MPI_Request mpi_request;
-      ::MPI_Isend(buf, count, to_mpi_type(datatype), dest, tag, to_mpi_comm(comm.mpi_comm), &mpi_request);
-
-      request->mpi_request = new ::MPI_Request(mpi_request);
-
-      request->ep_src = src_rank;
-      request->ep_tag = tag;
-      request->ep_datatype = datatype;
-      request->type = 1;
-      request->comm = comm;
-
-      return 0;
+      Debug("\nMPI_Isend_intercomm with EP_intracomm\n");
+      return ::MPI_Isend(buf, count, to_mpi_type(datatype), mpi_dest, mpi_tag, to_mpi_comm(comm->mpi_comm), to_mpi_request_ptr(*request));
     }
 
-    if(comm.is_intercomm) return MPI_Isend_intercomm(buf, count, datatype, dest, tag, comm, request);
-
-    // EP intracomm
-
-    //check_sum_send(buf, count, datatype, dest, tag, comm, 1);
-
-    int ep_src_loc  = comm.ep_comm_ptr->size_rank_info[1].first;
-    int ep_dest_loc = comm.ep_comm_ptr->comm_list->rank_map->at(dest).first;
-    int mpi_tag     = tag_combine(tag, ep_src_loc, ep_dest_loc);
-    int mpi_dest    = comm.ep_comm_ptr->comm_list->rank_map->at(dest).second;
-
-    request->ep_src  = src_rank;
-    request->ep_tag  = tag;
-    request->ep_datatype = datatype;
-
-    ::MPI_Request mpi_request;
-
-    ::MPI_Isend(buf, count, to_mpi_type(datatype), mpi_dest, mpi_tag, to_mpi_comm(comm.mpi_comm), &mpi_request);
-
-    request->mpi_request = new ::MPI_Request(mpi_request);
-    request->type = 1;    // used in wait
-    request->comm = comm;
-    request->buf = const_cast<void*>(buf);
-
-    //Message_Check(comm);
-
-    return 0;
-  }
-
-
-
-
-  int MPI_Issend(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request)
-  {
-    Debug("\nMPI_Issend with EP\n");
-
-    int src_rank;
-    MPI_Comm_rank(comm, &src_rank);
-
-    
-
-    if(!comm.is_ep)
+    else
     {
-      ::MPI_Request mpi_request;
-      ::MPI_Issend(buf, count, to_mpi_type(datatype), dest, tag, to_mpi_comm(comm.mpi_comm), &mpi_request);
-
-      request->mpi_request = new ::MPI_Request(mpi_request);
-      request->ep_src = src_rank;
-      request->ep_tag = tag;
-      request->ep_datatype = datatype;
-      request->type = 1;
-      request->comm = comm;
-
-      return 0;
+      Debug("\nMPI_Isend_intercomm with EP_intercomm\n");
+      return ::MPI_Isend(buf, count, to_mpi_type(datatype), mpi_dest, mpi_tag, to_mpi_comm(comm->ep_comm_ptr->intercomm->mpi_inter_comm), to_mpi_request_ptr(*request));
     }
-
-    if(comm.is_intercomm) return MPI_Issend_intercomm(buf, count, datatype, dest, tag, comm, request);
-
-    // EP intracomm
-
-    //check_sum_send(buf, count, datatype, dest, tag, comm, 1);
-
-    int ep_src_loc  = comm.ep_comm_ptr->size_rank_info[1].first;
-    int ep_dest_loc = comm.ep_comm_ptr->comm_list->rank_map->at(dest).first;
-    int mpi_tag     = tag_combine(tag, ep_src_loc, ep_dest_loc);
-    int mpi_dest    = comm.ep_comm_ptr->comm_list->rank_map->at(dest).second;
-    
-    request->ep_src = src_rank;
-    request->ep_tag = tag;
-    request->ep_datatype = datatype;
-
-    ::MPI_Request mpi_request;
-
-    ::MPI_Issend(buf, count, to_mpi_type(datatype), mpi_dest, mpi_tag, to_mpi_comm(comm.mpi_comm), &mpi_request);
-
-    request->mpi_request = new ::MPI_Request(mpi_request);
-    request->type = 1;    // used in wait
-    request->comm = comm;
-    request->buf = NULL;
-    
-
-    //Message_Check(comm);
-
-    return 0;
-  }
-  
-
-
-
-  int MPI_Isend_intercomm(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request)
-  {
-    Debug("MPI_Isend with intercomm\n");
-
-    //check_sum_send(buf, count, datatype, dest, tag, comm, 1);
-
-    int dest_remote_ep_rank    = comm.ep_comm_ptr->intercomm->remote_rank_map->at(dest).first;
-    int dest_remote_comm_label = comm.ep_comm_ptr->intercomm->remote_rank_map->at(dest).second;
-
-    int src_ep_rank    = comm.ep_comm_ptr->intercomm->size_rank_info[0].first;
-    int src_comm_label;
-
-    src_comm_label = comm.ep_comm_ptr->intercomm->local_rank_map->at(src_ep_rank).second;
-
-
-    
-
-    //Message_Check(comm);
-
-
-    if(dest_remote_comm_label == src_comm_label)       // mpi_dest differs
+  }
+
+
+
+
+  int MPI_Issend_mpi(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request)
+  {
+    Debug("\nMPI_Issend with MPI\n");
+    
+    int src_rank;
+    MPI_Comm_rank(comm, &src_rank);
+    
+    *request = new ep_request;
+    memcheck("new "<< *request <<" : in ep_lib::MPI_Issend_mpi, *request = new ep_request");
+
+    (*request)->mpi_request = new ::MPI_Request;
+    memcheck("new "<< (*request)->mpi_request <<" : in ep_lib::MPI_Issend_mpi, (*request)->mpi_request = new ::MPI_Request");
+      
+    (*request)->ep_src = src_rank;
+    (*request)->ep_tag = tag;
+    (*request)->ep_datatype = datatype;
+    (*request)->type = 1;
+    (*request)->comm = comm;
+    
+    return ::MPI_Issend(buf, count, to_mpi_type(datatype), dest, tag, to_mpi_comm(comm->mpi_comm), to_mpi_request_ptr(*request));
+  }
+
+
+  int MPI_Issend_intercomm(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request)
+  {
+    Debug("\nMPI_Issend_intercomm with EP\n");
+
+#ifdef _check_sum    
+    check_sum_send(buf, count, datatype, dest, tag, comm);
+#endif
+
+    int src_comm_label  = comm->ep_comm_ptr->comm_label;
+    int dest_comm_label = comm->ep_comm_ptr->intercomm->intercomm_rank_map->at(dest).second.second;
+    
+    int src_rank;
+    MPI_Comm_rank(comm, &src_rank);
+
+    
+    *request = new ep_request;
+    memcheck("new "<< *request <<" : in ep_lib::MPI_Issend_intercomm, *request = new ep_request");
+
+    (*request)->mpi_request = new ::MPI_Request;
+    memcheck("new "<< (*request)->mpi_request <<" : in ep_lib::MPI_Issend_intercomm, (*request)->mpi_request = new ::MPI_Request");
+    
+
+    int ep_src_loc  = comm->ep_rank_map->at(src_rank).first;
+    int ep_dest_loc = comm->ep_comm_ptr->intercomm->intercomm_rank_map->at(dest).first;
+    int mpi_tag     = tag_combine(tag, ep_src_loc, ep_dest_loc);
+    int mpi_dest    = comm->ep_comm_ptr->intercomm->intercomm_rank_map->at(dest).second.first;
+
+#ifdef _showinfo
+    printf("ep_src_loc = %d, ep_dest_loc = %d, mpi_src = %d, mpi_dest = %d, mpi_tag = %d\n", ep_src_loc, ep_dest_loc, comm->ep_comm_ptr->size_rank_info[2].first, mpi_dest, mpi_tag);
+#endif
+    
+    (*request)->ep_src  = src_rank;
+    (*request)->ep_tag  = tag;
+    (*request)->ep_datatype = datatype;
+
+    (*request)->type = 1;    // used in wait
+    (*request)->comm = comm;
+    (*request)->buf = const_cast<void*>(buf);
+
+
+    if(src_comm_label == dest_comm_label)
     {
-      int inter_src = comm.ep_comm_ptr->intercomm->local_rank_map->at(src_ep_rank).first;
-      int ep_src_loc = comm.rank_map->at(inter_src).first;
-      int ep_dest_loc = comm.rank_map->at(dest_remote_ep_rank).first;
-      int mpi_dest    = comm.rank_map->at(dest_remote_ep_rank).second;
-      int mpi_tag = tag_combine(tag, ep_src_loc, ep_dest_loc);
-
-      ::MPI_Request mpi_request;
-  
-      ::MPI_Isend(buf, count, to_mpi_type(datatype), mpi_dest, mpi_tag, to_mpi_comm(comm.mpi_comm), &mpi_request);
-
-      request->mpi_request = new ::MPI_Request(mpi_request);
-      request->type = 1;    // used in wait
-      request->comm = comm;
-
-      request->ep_src = src_ep_rank;
-      request->ep_tag = tag;
-      request->ep_datatype = datatype;
+      Debug("\nMPI_Issend_intercomm with EP_intracomm\n");
+      return ::MPI_Issend(buf, count, to_mpi_type(datatype), mpi_dest, mpi_tag, to_mpi_comm(comm->mpi_comm), to_mpi_request_ptr(*request));
     }
 
-    else   // dest_remote_comm_label != src_comm_label
-    { 
-      int inter_src = comm.ep_comm_ptr->intercomm->local_rank_map->at(src_ep_rank).first;
-      int ep_src_loc = comm.rank_map->at(inter_src).first;
-      int ep_dest_loc = comm.ep_comm_ptr->intercomm->intercomm_rank_map->at(dest_remote_ep_rank).first;
-      int mpi_dest    = comm.ep_comm_ptr->intercomm->intercomm_rank_map->at(dest_remote_ep_rank).second;
-      int mpi_tag = tag_combine(tag, ep_src_loc, ep_dest_loc);
-
-      ::MPI_Request mpi_request;
-
-      ::MPI_Isend(buf, count, to_mpi_type(datatype), mpi_dest, mpi_tag, to_mpi_comm(comm.ep_comm_ptr->intercomm->mpi_inter_comm), &mpi_request);
-
-      request->mpi_request = new ::MPI_Request(mpi_request);
-      request->type = 1;    // used in wait
-      request->comm = comm;
-   
-      request->ep_src = src_ep_rank;
-      request->ep_tag = tag;
-      request->ep_datatype = datatype;
+    else
+    {
+      Debug("\nMPI_Issend_intercomm with EP_intercomm\n");
+      return ::MPI_Issend(buf, count, to_mpi_type(datatype), mpi_dest, mpi_tag, to_mpi_comm(comm->ep_comm_ptr->intercomm->mpi_inter_comm), to_mpi_request_ptr(*request));
     }
-
-    return 0;
-
-  }
-
-
-  int MPI_Issend_intercomm(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request)
-  {
-    Debug("MPI_Issend with intercomm\n");
-
-    //check_sum_send(buf, count, datatype, dest, tag, comm, 1);
-
-    int dest_remote_ep_rank    = comm.ep_comm_ptr->intercomm->remote_rank_map->at(dest).first;
-    int dest_remote_comm_label = comm.ep_comm_ptr->intercomm->remote_rank_map->at(dest).second;
-
-    int src_ep_rank    = comm.ep_comm_ptr->intercomm->size_rank_info[0].first;
-    int src_comm_label;
-
-    for(int i=0; i<comm.ep_comm_ptr->intercomm->local_rank_map->size(); i++)
-    {
-      if(comm.ep_comm_ptr->intercomm->local_rank_map->at(i).first == src_ep_rank)
-      {
-        src_comm_label = comm.ep_comm_ptr->intercomm->local_rank_map->at(i).second;
-        break;
-      }
-    }
-
-    //Message_Check(comm);
-
-
-    if(dest_remote_comm_label == src_comm_label)       // dest rank (loc, mpi) differs
-    {
-      int inter_src = comm.ep_comm_ptr->intercomm->local_rank_map->at(src_ep_rank).first;
-      int ep_src_loc = comm.rank_map->at(inter_src).first;
-      int ep_dest_loc = comm.rank_map->at(dest_remote_ep_rank).first;
-      int mpi_dest    = comm.rank_map->at(dest_remote_ep_rank).second;
-      int mpi_tag = tag_combine(tag, ep_src_loc, ep_dest_loc);
-
-      ::MPI_Request mpi_request;
-  
-      ::MPI_Issend(buf, count, to_mpi_type(datatype), mpi_dest, mpi_tag, to_mpi_comm(comm.mpi_comm), &mpi_request);
-
-      request->mpi_request = new ::MPI_Request(mpi_request);
-      request->type = 1;    // used in wait
-      request->comm = comm;
-
-      request->ep_src = src_ep_rank;
-      request->ep_tag = tag;
-      request->ep_datatype = datatype;
-    }
-
-    else   // dest_remote_comm_label != src_comm_label
-    { 
-      int inter_src = comm.ep_comm_ptr->intercomm->local_rank_map->at(src_ep_rank).first;
-      int ep_src_loc = comm.rank_map->at(inter_src).first;
-      int ep_dest_loc = comm.ep_comm_ptr->intercomm->intercomm_rank_map->at(dest_remote_ep_rank).first;
-      int mpi_dest    = comm.ep_comm_ptr->intercomm->intercomm_rank_map->at(dest_remote_ep_rank).second;
-      int mpi_tag = tag_combine(tag, ep_src_loc, ep_dest_loc);
-
-      ::MPI_Request mpi_request;
-
-      ::MPI_Issend(buf, count, to_mpi_type(datatype), mpi_dest, mpi_tag, to_mpi_comm(comm.ep_comm_ptr->intercomm->mpi_inter_comm), &mpi_request);
-
-      request->mpi_request = new ::MPI_Request(mpi_request);
-      request->type = 1;    // used in wait
-      request->comm = comm;
-   
-      request->ep_src = src_ep_rank;
-      request->ep_tag = tag;
-      request->ep_datatype = datatype;
-    }
-
-    return 0;
-
   }
   
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_size.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_size.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_size.cpp	(revision 1520)
@@ -7,74 +7,47 @@
 {
 
-
-
-
   int MPI_Comm_size(MPI_Comm comm, int* size)
   {
-    
-    if(comm.is_ep)
+    if(comm->is_ep)
     {
-      if(!comm.is_intercomm)
-      {
-        *size = comm.ep_comm_ptr->size_rank_info[0].second;
-
-        return 0;
-      }
-      else
-      {
-        *size = comm.ep_comm_ptr->intercomm->size_rank_info[0].second;
-
-        return 0;
-      }
-
+      Debug("MPI_Comm_size with EP");
+      return *size = comm->ep_comm_ptr->size_rank_info[0].second;
     }
 
-    Debug("Calling EP_Comm_size\n");
-
-    if(comm.mpi_comm != static_cast< ::MPI_Comm*>(MPI_COMM_NULL.mpi_comm))
-    {
-      ::MPI_Comm mpi_comm = to_mpi_comm(comm.mpi_comm); 
-      int mpi_size;
-
-      ::MPI_Comm_size(mpi_comm, &mpi_size);
-      printf("============ ep comm size called for non ep comm, %d\n", mpi_size);
-      *size = mpi_size;
-      return 0;
-    }
-
-    else
-    {
-      *size = MPI_UNDEFINED;
-      printf("============ ep comm size called for non ep comm not defined\n");
-      return 0;
-    }
+    return MPI_Comm_size_mpi(comm, size);
   }
 
   int MPI_Comm_remote_size(MPI_Comm comm, int *size)
   {
-    if(!comm.is_ep)
+    if(comm->is_ep)
     {
-      if(comm.mpi_comm != static_cast< ::MPI_Comm*>(MPI_COMM_NULL.mpi_comm))
+      if(comm->is_intercomm)
       {
-        ::MPI_Comm mpi_comm = to_mpi_comm(comm.mpi_comm); 
-        ::MPI_Comm_remote_size(mpi_comm, size);
-        return 0;
+        Debug("MPI_Comm_remote_size with EP_intercomm");
+        return *size = comm->ep_comm_ptr->intercomm->intercomm_rank_map->size();
       }
-
       else
       {
-        *size = MPI_UNDEFINED;
-        return 0;
+        Debug("MPI_Comm_remote_size with EP_intracomm");
+        return *size=0;
       }
     }
-    
-    if(comm.is_intercomm)
-    {
-      *size = comm.ep_comm_ptr->intercomm->remote_rank_map->size();
-      return 0;
-    }
-    *size = MPI_UNDEFINED;
-    return 0; 
+    return MPI_Comm_remote_size_mpi(comm, size);
   }
+
+
+  int MPI_Comm_size_mpi(MPI_Comm comm, int* size)
+  {
+    Debug("MPI_Comm_size with MPI");
+    return ::MPI_Comm_size(to_mpi_comm(comm->mpi_comm), size);
+  }
+
+  int MPI_Comm_remote_size_mpi(MPI_Comm comm, int *size)
+  {
+    Debug("MPI_Comm_remote_size with MPI");
+    return ::MPI_Comm_remote_size(to_mpi_comm(comm->mpi_comm), size);
+  }
+
+
 }
 
